<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;

class GpeAltesalario extends \Doctrine\ORM\EntityRepository {
    
    
    public function retornaAlteSalarioAtualPorVinculoModalidade($nrorg, $dtAlterSalario, $nrVinculom, $nrModalidade){
        $params = array('nrorg'=>$nrorg, 'nrtpmodalidsal'=>$nrModalidade, 'dtaltesalario'=>$dtAlterSalario,
        'nrvinculom'=>$nrVinculom);
        $gpe_altesalario =  'Teknisa\Model\Gestaopessoas\Entities\GpeAltesalario';
        
$sql = <<<SQL
SELECT s FROM $gpe_altesalario s
WHERE s.nrorg = :nrorg
AND s.nrvinculom = :nrvinculom
AND s.nrtpmodalidsal = :nrtpmodalidsal
AND s.dtaltesalario in (
    SELECT MAX(ss.dtaltesalario) 
    FROM $gpe_altesalario ss
    WHERE ss.dtaltesalario <= :dtaltesalario
    AND s.nrorg = ss.nrorg
    AND s.nrvinculom = ss.nrvinculom
    AND s.nrtpmodalidsal = ss.nrtpmodalidsal)
ORDER BY s.dtaltesalario,s.nrocorrencia    
SQL;
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        if(!empty($result))
            return $result;
        else 
            return $result;
    }
    
    public function retornaAlteSalarioAtual($nrorg, $nrVinculom, $dtAlterSalario){
        $params = array('nrorg'=>$nrorg, 'nrvinculom'=>$nrVinculom, 'dtaltesalario'=>$dtAlterSalario);
        $gpe_altesalario =  'Teknisa\Model\Gestaopessoas\Entities\GpeAltesalario';
        
$sql = <<<SQL
SELECT s FROM $gpe_altesalario s
WHERE s.nrorg = :nrorg
AND s.nrvinculom = :nrvinculom
AND s.dtaltesalario in (
    SELECT MAX(ss.dtaltesalario) 
    FROM $gpe_altesalario ss
    WHERE ss.dtaltesalario <= :dtaltesalario
    AND s.nrorg = ss.nrorg
    AND ss.nrvinculom = s.nrvinculom)
SQL;
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        if(!empty($result))
            return $result[0];
        else 
            return $result;
    }
    
    public function retornaAlteSalarioTodas($nrorg, $dtAlterSalario, $nrVinculom, $nrModalidade){
        $params = array('nrorg'=>$nrorg, 'nrvinculom'=>$nrVinculom, 'dtaltesalario'=>$dtAlterSalario, 'nrtpmodalidsal'=>$nrModalidade);
        $gpe_altesalario =  'Teknisa\Model\Gestaopessoas\Entities\GpeAltesalario';
        
$sql = <<<SQL
SELECT s FROM $gpe_altesalario s
WHERE s.nrorg = :nrorg
AND s.nrvinculom = :nrvinculom
AND s.nrtpmodalidsal = :nrtpmodalidsal
AND s.dtaltesalario <= :dtaltesalario
ORDER BY s.dtaltesalario ASC
SQL;

        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return $result;
    }
}